#include <malloc.h>
#include <stdio.h>
#include <stdlib.h>
#include <time.h>

#include <iostream>
#include <fstream>

#if defined(_WIN32)
#include <io.h>
#include <share.h>
#include <sys\stat.h>
#else
#include <sys/stat.h>
#include <alloc.h>
#endif

#include "sufixtree_original.h"

#define NODESIZE 16
#define TFILLSIZE 16 /*4X4*/

// Per imprimir els suffix trees
// (utilitza la variable lastnum i el camp num dels nodes)
//void printsf(int i,TNode *n);
void split2(unsigned char *, int &);


long i,j;			/* contadors buffer i del segment del TNode */
long inf;			/* fora de l'abast (MAX+1) */
TNode *snact;			/* pntr. al TNode actual */
long g;				/* tam. del segment del TNode */
int nfills_root = 4;		/* comptador de nfills del root no tractats */
clock_t start, end;

TNode **nfill    = NULL; 
TNode **sflinkn = NULL;
TNode **sflinkv = NULL;
TNode *aux      = NULL;
TNode **nfills; 



// fill exiteix => avancem
void fill_existeix(){
  snact = *nfills;
  j = snact->ini+1;
  i++;
}

// fill no existeix => el creem
void fill_NOexisteix(int &num){
  *nfills = (TNode *) malloc(sizeof(TNode));
  (*nfills)->nfills = NULL;
  (*nfills)->ini = i;
  (*nfills)->fi = inf;
  (*nfills)->sflink = NULL;
  (*nfills)->num = num++;
  (*nfills)->tlink = NULL;
}

// Seguim suffix links (busquem posicio equivalent)
// cas que s'hagi fet un add (fill_NOexisteix)
// com que pot ser que nomes seguint el suffix link no trobem pos. eq. =>
// utilitzem comptador g (indica # de caracters que queden)
void pos_eq(unsigned char *seq){
  sflinkn = &(*nfills)->sflink;
  g = snact->fi - snact->ini;
  snact = snact->sflink;
  while (g -= snact->fi - snact->ini) {
    snact=snact->nfills[seq[i-g]];
  }
}

// Busquem posicio equivalent (seguint suffix links)
// cas que estiguem seguint els suffix links de split
void pos_eq2(unsigned char *seq, int &num){

  g = snact->fi - snact->ini;
  snact = snact->sflink;
  while ((g -= snact->fi - snact->ini)>0) {
    snact=snact->nfills[seq[i-g]];
  }

 // si g>0 => queden caracters per lletrejar que no coincideixen (split)
 while (g){
    g += snact->fi; 
    split2(seq, num);
    g = g - snact->ini;
    // seguim suffix links
    snact = snact->sflink;
    while((g-= snact->fi -snact->ini)>0) {
      snact = snact->nfills[seq[i-g]];
    }
  }
}

// funcio split (cas en que estiguem fent splits seguint els suffix links)
// g es la posicio per on hem de partir
void split2(unsigned char *seq, int &num){

    // node vell 
    aux = (TNode *) malloc(sizeof(TNode));
    aux->nfills = snact->nfills;
    aux->ini = g;
    aux->fi = snact->fi;
	aux->num = snact->num;
	aux->tlink = NULL;
    
    *sflinkv = aux; /* actualitzem sflinkv */
    sflinkv = &aux->sflink;

    snact->nfills = (TNode **) calloc(5,sizeof(TNode *));
    snact->nfills[seq[g]] = aux;
	snact->num = 2;

    // creacio nou node
    aux = (TNode *) malloc(sizeof(TNode));
    aux->nfills = NULL;
    aux->ini = i;
    aux->fi = inf;
	aux->num = num++;
	aux->tlink = NULL;
    // aux->num=lastnum;lastnum++;
    *sflinkn = aux; /* actualitzem sflinkn */
    sflinkn = &aux->sflink;

    snact->nfills[seq[i]] = aux;
    snact->fi = g; /* j-1 ultima base igual */
}

// funcio split (primer split)
// j es la posicio per on s'ha de partir
void split(unsigned char *seq, int &num){

  // creacio node vell
  aux = (TNode *) malloc(sizeof(TNode));
  aux->nfills = snact->nfills; // mateixos fills
  aux->ini = j;
  aux->fi = snact->fi;
  aux->tlink = NULL;
  aux->num =  snact->num;
  sflinkv = &aux->sflink; // apuntem el suffix link

  snact->nfills = (TNode **) calloc(5,sizeof(TNode *));
  snact->nfills[seq[j]] = aux;
  snact->num = 2;

  // creacio nou node
  aux = (TNode *) malloc(sizeof(TNode));
  aux->nfills = NULL;
  aux->ini = i;
  aux->fi = inf;
  aux->num = num++;
  aux->tlink = NULL;
  sflinkn = &aux->sflink; // actualitzem suff link

  snact->nfills[seq[i]] = aux;
  snact->fi = j; /* j-1 ultima base igual */
  
}


TNode *crea_arbre(unsigned char *seq, int size){

 start = clock();

 /* inicialitzacio de l'arbre */
 int num = 0;

 // node arrel
 TNode *root = (TNode *)malloc(sizeof(TNode));
 root->ini = 0; /* g=1 per restar 1 als fills del root */
 root->fi = 1;
 root->num=0;
 root->tlink = NULL;
 sflinkn = &root->sflink; /* sftlink apuntara a si mateix */
 root->nfills = (TNode**)calloc(5,sizeof(TNode *)); /* link a la taula de bases (4x16)*/

 snact = root;
 inf = size + 1;

 j = 1; /* j==snact->fi */
 i = 0;
 *sflinkn = snact;
 bool ini=true;
 
  while(i<size+1){

    if(ini || ( (*nfills) && (*nfills)->sflink ) ){
      ini=false;
      if (j==snact->fi){ // final d'etiqueta del node
        // avancem pel fill corresponent
        nfills = &snact->nfills[seq[i]];
        if (*nfills){ 
          fill_existeix(); // fill existeix => avancem
        }
        else {
          fill_NOexisteix(num); // fill no existeix => el creem
		  snact->num++;
          pos_eq(seq); // busquem posicio equivalent seguint suff links
          // g==0
          nfills = &snact->nfills[seq[i]];
          // Mentre el fill no existeixi: creem nou fill i seguim suffix links
          while(!*nfills){
            fill_NOexisteix(num); // crear nou fill
			snact->num++;
            *sflinkn = *nfills;
            pos_eq(seq); // seguim suff link
            // g==0
            nfills = &snact->nfills[seq[i]];
          }
          if ((*nfills)->sflink){
            snact = *nfills;
            *sflinkn = snact;
          }
          j = snact-> ini+1;
          i++;
        }
      } //j==fi
      else if (seq[j]==seq[i]){ // caracters coincideixen
        i++;
        j++;
      }
      else if (seq[j]!=seq[i]){ // caracters no coincideixen => split

        split(seq, num); // split
        pos_eq2(seq, num); // busquem posicio equivalent
        // g==0
        nfills = &snact->nfills[seq[i]];     
        if (*nfills){
        // fill posicio equivalent existeix => atualitzem suff link i avancem
           *sflinkv = snact->nfills[seq[j]];
           fill_existeix();
           *sflinkn=snact;
        }
        else {
        // fill posicio equivalent no existeix => el creem i actualitzem suff link
          fill_NOexisteix(num);
		  snact->num++;
          *sflinkn = *nfills; /* actualitzem sflinkn i v */
          *sflinkv = snact->nfills[seq[j]];
          pos_eq(seq); // busquem seguent pos. eq.
          // g==0
          nfills = &snact->nfills[seq[i]];

          while(!*nfills){
            fill_NOexisteix(num);
			snact->num++;
            *sflinkn = *nfills;
            pos_eq(seq);
            // g==0
            nfills = &snact->nfills[seq[i]];
          }
          fill_existeix();
          // si es fill arrel, es el q acabo de crear
          if ((*nfills)->sflink) {
            *sflinkn=snact;
          }
        }
      }
    }
    if( !((*nfills)->sflink)){ // suff link apunta a l'arrel
      snact = root; /* redefinim snact,sflinkn i j */
      *sflinkn = snact; /* sflinkn = &fill->sflink , snact = root */
      j = snact->ini+1;
    }
  }
  if (!root->nfills[1])
    root->nfills[1] = root;
 if (!root->nfills[2])
    root->nfills[2] = root;
 if (!root->nfills[3])
    root->nfills[3] = root;
 if (!root->nfills[4])
    root->nfills[4] = root;
  return root;
}
