#include <malloc.h>
#include <stdio.h>
#include <stdlib.h>
#include <time.h>


#include <vector>
#include <iostream>
#include <fstream>

#if defined(_WIN32)
#include <io.h>
#include <share.h>
#include <sys\stat.h>
#else
#include <sys/stat.h>
#include <alloc.h>
#endif

#include "sufixtree_original.h"

#define NODESIZE 16
#define TFILLSIZE 16 /*4X4*/

#define Min(a, b) ((a) <= (b) ? (a) : (b))
#define Max(a, b) ((a) >= (b) ? (a) : (b))

using namespace std;

typedef struct UM UM;

struct UM {
	int UP;
	int EP;
};

typedef struct Mum Mum;
struct Mum {
	int SP;
	int LON;
};

unsigned char Sf[128];		/* taula de conversio char2int */

bool match_prefix(TNode *node, unsigned char **s, unsigned char *s0);
	//Pre: the first is match ever (even the root)
	//Post: s point to first mismatch
	//		 at_final --> fi_pre == node.fi
	//		 sb point to first in the node
	//       fi_pre = fist mismatch in the node
	//		 if node == root --> s = sb; fi_pre = root.fi

TNode *
tlink_node(TNode *node, int *PosLabel, int &ppl, bool *B, int &pb)
{
	TNode *aux     = node;

	PosLabel[ppl++] = node->ini;
	do {			     // loop that go to the tnode of the chain
		node     = node->sflink;
		//B[pb++]  = node->nfills != NULL;
	} while (!node->nfills);
	aux->tlink = node;
	B[pb++]  = 1;
	while (aux->sflink != node) {	// loop the chain
		B[pb++]  = 0;
		aux = aux->sflink;
		PosLabel[ppl++] = aux->ini;
		aux->tlink = node;
	}
	return node;
}

void 
add_tlink(TNode *node, bool *B, unsigned char *seq, int *PosLabel) {
	int ppl = 0;
	int pb  = 0;
	unsigned char *s = seq;

	while (*seq) {
		node = node->nfills[*seq++];
		if (!node->nfills)
			node = tlink_node(node, PosLabel, ppl, B, pb);
		seq += node->fi - node->ini - 1;
	}
	
	int i = 0;
/*	cout << "VECTOR B\n";
	while (*s++) {
		cout << "B[" << i << "] = "<< B[i] << "\n";
		i++;
	}*/
}


// llegim la sequenci
unsigned char* get_seq(char *name,long int &size) {
	long i_b;
	ifstream in(name);
	char c;
	unsigned char* seq;
	
	in.seekg(0,ios::end);  	// go to the end of the file
	size = in.tellg(); 	// get the current position in the file
	in.seekg(0);            // go back to the beginning of the file
	
	/* inicialitza taula char2int */
	Sf['t'] = Sf['T'] = 4;
	Sf['g'] = Sf['G'] = 3;
	Sf['c'] = Sf['C'] = 2;
	Sf['u'] = Sf['U'] = 4;
	Sf['a'] = Sf['A'] = 1;
	Sf['$'] = 0;
	if (!in.is_open()) { 
		cout << "Error opening file"; 
		exit (1); 
	}
	if(!(seq = new unsigned char[size + 2])) { 
		printf("size NOK \n");
		exit(0);
	}
	
	i_b = 0;
	while (!in.eof()) {
		in.get(c);
		if (c != '\n' && !in.eof()) {
		  seq[i_b++] = Sf[c];
		  //cout << c;
		}
	}
	cout << "$\n";
	seq[i_b]   = 0;
	seq[i_b+1] = '\0';
	in.close();
	size = i_b;
	
	return seq;
}

//long lastnum=0;



/////////////////////////////////////////////////////////////////////////////////////////////////

TNode *new_leaf(TNode *pare, int ini, int fi, int num
				, unsigned char *seq, TNode *old)
{
	TNode *leaf = new TNode;
	 
	leaf->ini = ini;
	leaf->fi  = fi;
	leaf->num = num;
	leaf->nfills = NULL;
	leaf->sflink = leaf;
	leaf->tlink  = leaf;
	
	pare->nfills[seq[ini]] = leaf;
	if (old)
		old->sflink = leaf;
	return leaf;
}

bool match_prefix(TNode *node, unsigned char **s, unsigned char *s0)
{
	// si node final --> no fem res i es true
	// si arrel      --> final true i adelanta una pos
	// s apunta al primer mismatch
	int k = node->ini;

	if (k == node->fi) 
		return true;
	while ((k < node->fi) && (s0[++k] == *++*s));
	return node->nfills ? (k == node->fi) : (s0[k] == **s);
}


bool sf_match_prefix(TNode *node, unsigned char **s, unsigned char *s0)
{
	int k = node->ini;

	if (node->sflink == node)
		return true;
	while ((k < node->fi) && (s0[++k] == *++*s));
	return node->nfills ? (k == node->fi) : (s0[k] == **s);
}


void crear_fills_buit(TNode *node)
{
	if (!node->nfills) {
		node->nfills = new TNode *[5];
		node->nfills[0]   = node->nfills[1] = node->nfills[2]
		= node->nfills[3] = node->nfills[4] = NULL;
	}
}


TNode *crear_sf(unsigned char *seq, int size)
{
	TNode *node = new TNode;
	bool is_final = true;
	TNode *newleaf = NULL;
	TNode *newsplit = NULL;
	unsigned char *s = seq;
	unsigned char *sb = s;
	bool is_next = true;
	TNode *nextnode;
	TNode *root = node;
	int  l;
	bool is_root = true;
	int  lnew;
	int  i;
	int splitini;
	int num = 0;

	node->ini = 0;
	node->fi  = 1;
	node->nfills = NULL;
	node->sflink = node;
	crear_fills_buit(node);
	node->num = 0;

	while (num < size) {
		l       = node->fi - node->ini;
		is_root = node == root;
		is_final = is_final || sf_match_prefix(node, &s, seq);
		lnew    = s - sb + (is_root ? 1 : 0);
		nextnode = node->nfills ? node->nfills[*s] : NULL;
		if ((is_next && is_final && nextnode) || (!is_next && l <= lnew)) {
			if (!is_next && l < lnew && !is_root)
				sb = sb + l;
			else if (is_next || l == lnew)
				sb = s;

			if (is_next) {
				node = nextnode;
				if (newleaf) {
					newleaf->sflink = nextnode;
					newleaf = NULL;
				}
			} else if (l < lnew) {
				node = node->nfills[*sb];
			} else if (l == lnew && newsplit) {
				newsplit->sflink = node->nfills[seq[newsplit->ini]];
				newsplit = NULL;
			}			
			is_final = !is_next;
			is_next = is_next || (l == lnew);
		} else { 
			if (is_next && is_final) 
				sb = s + (is_root ? 1 : - l) ;
			else if (!is_final)
				newleaf = NULL;
			i = s - seq;
			is_final = true;
			lnew = s - sb;
			crear_fills_buit(node);
			newleaf = new_leaf(node, i, size, num++, seq, newleaf);
			node->nfills[*s] = newleaf;
			if (lnew == -1) {
				newleaf->sflink = node;
				newleaf  = NULL;
				s = s + 1;
				is_next = true;
				node->num++;
			} else {
				if (l > lnew) {
					splitini = node->ini + lnew;
					newsplit = new_leaf(node, splitini, size
					, node->num, seq, newleaf);
					node->nfills[seq[splitini]] = newsplit;
					node->fi = splitini;
					node->num = 1;
				} else 
					newsplit = NULL;
				node->num++;
				node = node->sflink;
				if (node == node->sflink)
					sb++;
				is_next = false;
			}
		}
	}
	newleaf = new_leaf(node, size, size, num, seq, newleaf);
	node->nfills[0] = newleaf;
	newleaf->sflink = node;
	node->num++;
	if (!node->nfills[1])
		node->nfills[1] = newleaf;
	if (!node->nfills[2])
		node->nfills[2] = newleaf;
	if (!node->nfills[3])
		node->nfills[3] = newleaf;
	if (!node->nfills[4])
		node->nfills[4] = newleaf;
	return node;
}





/////////////////////////////////////////////////////////////////////////////////////////////////

void printsf(int i,TNode *r){
if (r){
	if (r->tlink)
		cout<<i<<" --- ["<<r->ini<<','<< r->fi << ", " << r->num << "] ::::::-> [" 
		<< r->tlink->ini << "," << r->tlink->fi << ", " << r->tlink->num << "]" << endl;
	else 
		cout<<i<<" --- ["<<r->ini<<','<< r->fi << "]" << endl;
  cout<<endl;
  for(int i=0;i<5;i++){
    if(r->nfills){
      TNode *n=r->nfills[i];
      if (n) printsf(i,n);
    }
  }
}
}

//////////////////////////////////////////////////////////////////////
// Nou per a buscar mums
//////////////////////////////////////////////////////////////////////
// test

void
Test_UM(UM *Pair, int k, int l, int MMP, bool *B, int *SP, int size
#if defined(DEBUG)
  , unsigned char *s
#endif
) {
	int j = l;

#if defined(DEBUG)
char conv[5] = {'$','a','c','g','t'};
cout << "Find UM[" << l+1 << "," << MMP << "]: ";
for (int i = l; i < MMP; i++) cout << conv[s[i]]; cout << endl;
#endif
	if (MMP > Pair[j].UP) {
		do {
			Pair[j].UP = Min(MMP, Pair[j].EP);
#if defined(DEBUG)
cout << "UP[" << j + 1<< "]: " << Pair[j].UP + 1<< "\t";
#endif
			if (MMP > Pair[j].EP) {
				SP[j] = k - MMP + j;
#if defined(DEBUG)
cout << "SP[" << j + 1<< "]: " << SP[j] + 1<< "\t";
#endif				
			}
			Pair[j].EP = Max(MMP, Pair[j].EP);
#if defined(DEBUG)
cout << "EP[" << j << "]: " << Pair[j].EP << endl;
#endif
			j++;
		} while (!B[j] && j <= size && (MMP > Pair[j].UP));
	}
}




void write_state(unsigned char *s0, unsigned char *s, unsigned char*sb
, TNode *node, bool next)
{
  char conv[5] = {'$','a','c','g','t'};

  cout << "prefix comu dins el node: ";
  while (sb < s) cout << conv[*sb++]; cout << "[" << conv[*s] << "]\n";
  
  if (node->sflink == node)
    cout << "[arrel]";
  else if (node->nfills) {
    cout << "Node [" << node->ini+1 << "," << node->fi << "]:";
    for (int i=node->ini; i< node->fi; i++) cout << conv[s0[i]];
    if (next)
      cout << " |--> " << conv[s0[node->fi]];
  } else {
    cout << "Fulla [" << node->ini+1 << ",inf : l = " << node-> num << "]:";
    for (int i=node->ini; i< node->fi; i++) cout << conv[s0[i]];
  }
  cout << endl;
}

void
Find_UM(TNode *node, int size, unsigned char *s0, unsigned char *s
, int *PosLabel, bool *B, int *SP, UM *Pair) {
	bool          is_final_of_node  = true;
	unsigned char *seq              = s;
	TNode         *can_advance;
	TNode         *root = node;
	unsigned char *sb;

	node = node->nfills[*s];	// start in the first match node
	while (*s) {
		if (!node) {	// estem a l' ultime node
			node = root;
			s++;
		}
		sb = s;
		is_final_of_node = match_prefix(node, &s, s0);
		// si node final --> no fem res i es true
		// si arrel      --> final true i adelanta una pos
		// s apunta al primer mismatch
		
		// si es final i node_inten --> mirar si podem seguir
		// si es final i es fulla   --> estem al final de la seq.
		can_advance  = node->nfills ? node->nfills[*s] : NULL;
#if defined(DEBUG)
		write_state(s0, s, sb, node, can_advance);
#endif
		if (!node->nfills) {  // node is a leaf
			int x   = s - sb;
			int MMP = node->ini + x; // First Mismatch position
			int k   = s - seq;	 // positionof UM for seq_i
			Test_UM(Pair, k, node->num, MMP, B, SP, size
#if defined(DEBUG)
, s0 
#endif
);
		}		
		if (!can_advance || !is_final_of_node) {	
     // Condition: the nodes can be leaf or internal. If the node
     // is internal, there are two cases:
     //		1.- all the node has been read and the next node for the
     //			input sequence not exist.
     //		2.- there are a mismatch in.
			node = (!node->nfills) ? node->tlink : node->sflink;
			s = sb;
			//if (node == node->sflink)
			//	s++;
		} else
			node = can_advance;
	}
}

void
Intersect_UM(UM *Master, UM *Pair, int *PosLabel, int size)
{
	int k = -1;

	while (++k < size) {
		//cout << "Master before UP[" << k << "]: " << Master[k].UP << "\t";
		//cout << "EP[" << k << "]: " << Master[k].EP << endl;
		Master[k].UP = Max(Master[k].UP, Pair[k].UP);
		Master[k].EP = Min(Master[k].EP, Pair[k].EP);

		//cout << "Master after UP[" << k << "]: " << Master[k].UP << "\t";
		//cout << "EP[" << k << "]: " << Master[k].EP << endl;
		Pair[k].EP = Pair[k].UP = PosLabel[k];
	}
}


vector<Mum> * 
Search_MUM(UM *Master, int size, int max_lon)
{
	vector<Mum>  *ListMums = new vector<Mum>();
	int k   = -1;
	Mum MUM;
	int M_EP = 0;

	MUM.SP = 0;
	while (++k < size) 
		if ((Master[k].EP > M_EP) && (Master[k].UP < Master[k].EP)) {
			MUM.SP  = k;
			M_EP    = Master[k].EP;
			MUM.LON = M_EP - k;
			if (MUM.LON >= max_lon)
			  ListMums->push_back(MUM);
		}
	return ListMums;
}

vector<Mum>  *
Find_MUM(int nseqs, char **filenames, int max_lon)
{
	vector<unsigned char *> seq; 	/* array de sequencies sequencies */
	long int size;		 	/* size of tree sequence          */
	bool *B;			/* vector de "bits" */
	int *PosLabel;
	int **SP;
	TNode *root;
	long int seq_size;
	UM *Master;
	UM *Pair;
	vector<Mum>  *ListMums;

	int i;

	seq.push_back(get_seq(*++filenames, size));
	while (*++filenames)
		seq.push_back(get_seq(*filenames, seq_size));

	//root = crear_sf(seq[0], size);
	root = crea_arbre(seq[0], size);
	PosLabel = new int[size];
	B        = new bool[size];
	Master   = new UM[size];
	Pair     = new UM[size];


	add_tlink(root, B, seq[0], PosLabel); 
	//printsf(-1,root);

	// Initialize of Master
	for (i = 0; i < size; i++) {
		Pair[i].UP = Pair[i].EP = Master[i].UP = PosLabel[i];
		Master[i].EP = size;
	}
	
	// Initialize of SP
	SP = new int *[seq.size()];

	for (i = 1; i < seq.size(); i++) {
		SP[i] = new int[size];
		Find_UM(root, size, seq[0], seq[i], PosLabel, B, SP[i], Pair);
		Intersect_UM(Master, Pair, PosLabel, size);
	}
	
	ListMums  = Search_MUM(Master,size, max_lon);
	// eliminar memoria !!
	
	cout << "MUMs\n";
	for (i = 0; i < ListMums->size(); i++) {
		for (int j = 1; j < seq.size(); j++)
			cout << SP[j][(*ListMums)[i].SP] + 1 << " ";
		cout << (*ListMums)[i].SP + 1 
		<< " " << (*ListMums)[i].LON ;
		cout << endl;
	}


	return ListMums;
}

int main(int argc, char *argv[])
{
	vector<Mum>  *ListMums;
	int max_lon = atoi(*++argv);


	ListMums = Find_MUM(argc - 1, argv++, max_lon);

	exit(0);
}

